: Class RotPosScalePathInterpolator

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.media.j3d
Class RotPosScalePathInterpolator

    java.lang.Object
      |
      +--javax.media.j3d.SceneGraphObject
            |
            +--javax.media.j3d.Node
                  |
                  +--javax.media.j3d.Leaf
                        |
                        +--javax.media.j3d.Behavior
                              |
                              +--javax.media.j3d.Interpolator
                                    |
                                    +--javax.media.j3d.PathInterpolator
                                          |
                                          +--javax.media.j3d.RotPosScalePathInterpolator

public class RotPosScalePathInterpolator
extends PathInterpolator

RotPosScalePathInterpolation behavior. This class defines a behavior that varies the rotational, translational, and scale components of its target TransformGroup by linearly interpolating among a series of predefined knot/position, knot/orientation, and knot/scale pairs (using the value generated by the specified Alpha object). The interpolated position, orientation, and scale are used to generate a transform in the local coordinate system of this interpolator. The first knot must have a value of 0.0. The last knot must have a value of 1.0. An intermediate knot with index k must have a value strictly greater than any knot with index less than k.

Fields inherited from class javax.media.j3d.PathInterpolator
`currentInterpolationValue, currentKnotIndex`

Fields inherited from class javax.media.j3d.Interpolator
`defaultWakeupCriterion`

Fields inherited from class javax.media.j3d.Node
`ALLOW_AUTO_COMPUTE_BOUNDS_READ, ALLOW_AUTO_COMPUTE_BOUNDS_WRITE, ALLOW_BOUNDS_READ, ALLOW_BOUNDS_WRITE, ALLOW_COLLIDABLE_READ, ALLOW_COLLIDABLE_WRITE, ALLOW_LOCAL_TO_VWORLD_READ, ALLOW_PICK, ALLOW_PICKABLE_READ, ALLOW_PICKABLE_WRITE, ENABLE_COLLISION_REPORTING, ENABLE_PICK_REPORTING`

Constructor Summary
`RotPosScalePathInterpolator(Alpha alpha, TransformGroup target, Transform3D axisOfRotPosScale, float[] knots, Quat4f[] quats, Point3f[] positions, float[] scales)` Constructs a new RotPosScalePathInterpolator object that varies the rotation, translation, and scale of the target TransformGroup's transform.

Method Summary
`Node` | `cloneNode(boolean forceDuplicate)` Used to create a new instance of the node.
`void` | `duplicateNode(Node originalNode, boolean forceDuplicate)` Copies all node information from `originalNode` into the current node.
`Transform3D` | `getAxisOfRotPosScale()` This method retrieves this interpolator's axis of rotation, translation, and scale.
`void` | `getPosition(int index, Point3f position)` This method retrieves the position value at the specified index.
`void` | `getQuat(int index, Quat4f quat)` This method retrieve the quat value at the specified index.
`float` | `getScale(int index)` This method retrieves the scale at the specified index.
`TransformGroup` | `getTarget()` This method retrieves this interpolator's target TransformGroup reference.
`void` | `processStimulus(java.util.Enumeration criteria)` This method is invoked by the behavior scheduler every frame.
`void` | `setAxisOfRotPosScale(Transform3D axisOfRotPosScale)` This method sets the axis of rotation, translation, and scale for this interpolator, RotPosScale, which defines the local coordinate system in which this interpolator operates.
`void` | `setPosition(int index, Point3f position)` This method sets the position value at the specified index for this interpolator.
`void` | `setQuat(int index, Quat4f quat)` This method sets the quat value at the specified index for this interpolator.
`void` | `setScale(int index, float scale)` This method sets the scale at the specified index for this interpolator.
`void` | `setTarget(TransformGroup target)` This method sets the target TransformGroup for this interpolator.
`void` | `updateNodeReferences(NodeReferenceTable referenceTable)` Callback used to allow a node to check if any scene graph objects referenced by that node have been duplicated via a call to `cloneTree`.

Methods inherited from class javax.media.j3d.PathInterpolator
`computePathInterpolation, getArrayLengths, getKnot, setKnot`

Methods inherited from class javax.media.j3d.Interpolator
`getAlpha, initialize, setAlpha`

Methods inherited from class javax.media.j3d.Behavior
`getEnable, getSchedulingBoundingLeaf, getSchedulingBounds, getView, postId, setEnable, setSchedulingBoundingLeaf, setSchedulingBounds, wakeupOn`

Methods inherited from class javax.media.j3d.Node
`cloneTree, cloneTree, cloneTree, getBounds, getBoundsAutoCompute, getCollidable, getLocalToVworld, getLocalToVworld, getParent, getPickable, setBounds, setBoundsAutoCompute, setCollidable, setPickable`

Methods inherited from class javax.media.j3d.SceneGraphObject
`clearCapability, duplicateSceneGraphObject, getCapability, getUserData, isCompiled, isLive, setCapability, setUserData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RotPosScalePathInterpolator

    public RotPosScalePathInterpolator(Alpha alpha,
                                       TransformGroup target,
                                       Transform3D axisOfRotPosScale,
                                       float[] knots,
                                       Quat4f[] quats,
                                       Point3f[] positions,
                                       float[] scales)

  Constructs a new RotPosScalePathInterpolator object that varies the rotation, translation, and scale of the target TransformGroup's transform.
  Parameters:
    `alpha` - the alpha object for this interpolator
    `target` - the TransformGroup node affected by this interpolator
    `axisOfRotPosScale` - the transform that specifies the local coordinate system in which this interpolator operates
    `knots` - an array of knot values that specify a spline
    `quats` - an array of quaternion values at the knots
    `positions` - an array of position values at the knots
    `scales` - an array of scale component values

Method Detail

### setScale

    public void setScale(int index,
                         float scale)

  This method sets the scale at the specified index for this interpolator.
  Parameters:
    `index` - the index to be changed
    `scale` - the new scale at index

### getScale

    public float getScale(int index)

  This method retrieves the scale at the specified index.
  Parameters:
    `index` - the index of the value requested
  Returns:
    the interpolator's scale value at index

### setQuat

    public void setQuat(int index,
                        Quat4f quat)

  This method sets the quat value at the specified index for this interpolator.
  Parameters:
    `index` - the index to be changed
    `quat` - the new quat value at index

### getQuat

    public void getQuat(int index,
                        Quat4f quat)

  This method retrieve the quat value at the specified index.
  Parameters:
    `index` - the index of the value requested
  Returns:
    the interpolator's quat value at the index

### setPosition

    public void setPosition(int index,
                            Point3f position)

  This method sets the position value at the specified index for this interpolator.
  Parameters:
    `index` - the index to be changed
    `position` - the new position value at index

### getPosition

    public void getPosition(int index,
                            Point3f position)

  This method retrieves the position value at the specified index.
  Parameters:
    `index` - the index of the value requested
  Returns:
    the interpolator's position value at the index

### setAxisOfRotPosScale

    public void setAxisOfRotPosScale(Transform3D axisOfRotPosScale)

  This method sets the axis of rotation, translation, and scale for this interpolator, RotPosScale, which defines the local coordinate system in which this interpolator operates.
  Parameters:
    `axisOfRotPosScale` - the interpolators axis of RotPosScale

### getAxisOfRotPosScale

    public Transform3D getAxisOfRotPosScale()

  This method retrieves this interpolator's axis of rotation, translation, and scale.
  Returns:
    the interpolator's axis of RotPosScale

### setTarget

    public void setTarget(TransformGroup target)

  This method sets the target TransformGroup for this interpolator.
  Parameters:
    `target` - the target TransformGroup reference

### getTarget

    public TransformGroup getTarget()

  This method retrieves this interpolator's target TransformGroup reference.
  Returns:
    the interpolator's target TransformGroup reference

### processStimulus

    public void processStimulus(java.util.Enumeration criteria)

  This method is invoked by the behavior scheduler every frame. It maps the alpha value that corresponds to the current time into translation, rotation, and scale values, computes a transform based on these values, and updates the specified TransformGroup node with this new transform.
  Overrides:
    processStimulus in class Behavior
  Parameters:
    `criteria` - enumeration of criteria that have triggered this wakeup

### cloneNode

    public Node cloneNode(boolean forceDuplicate)

  Used to create a new instance of the node. This routine is called by `cloneTree` to duplicate the current node.
  Overrides:
    cloneNode in class Node
  Parameters:
    `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
  See Also:
    `Node.cloneTree()`, `Node.cloneNode(boolean)`, `Node.duplicateNode(javax.media.j3d.Node, boolean)`, `NodeComponent.setDuplicateOnCloneTree(boolean)`

### duplicateNode

    public void duplicateNode(Node originalNode,
                              boolean forceDuplicate)

  Copies all node information from `originalNode` into the current node. This method is called from the `cloneNode` method which is, in turn, called by the `cloneTree` method.

  For any NodeComponent objects contained by the object being duplicated, each NodeComponent object's `duplicateOnCloneTree` value is used to determine whether the NodeComponent should be duplicated in the new node or if just a reference to the current node should be placed in the new node. This flag can be overridden by setting the `forceDuplicate` parameter in the `cloneTree` method to `true`.

  Overrides:
    duplicateNode in class PathInterpolator
  Parameters:
    `originalNode` - the original node to duplicate.
    `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
  See Also:
    `Node.cloneTree()`, `Node.cloneNode(boolean)`, `NodeComponent.setDuplicateOnCloneTree(boolean)`

### updateNodeReferences

    public void updateNodeReferences(NodeReferenceTable referenceTable)

  Callback used to allow a node to check if any scene graph objects referenced by that node have been duplicated via a call to `cloneTree`. This method is called by `cloneTree` after all nodes in the sub-graph have been duplicated. The cloned Leaf node's method will be called and the Leaf node can then look up any object references by using the `getNewObjectReference` method found in the `NodeReferenceTable` object. If a match is found, a reference to the corresponding object in the newly cloned sub-graph is returned. If no corresponding reference is found, either a DanglingReferenceException is thrown or a reference to the original object is returned depending on the value of the `allowDanglingReferences` parameter passed in the `cloneTree` call.
  Overrides:
    updateNodeReferences in class Behavior
  Parameters:
    `referenceTable` - a NodeReferenceTableObject that contains the `getNewObjectReference` method needed to search for new object instances.
  See Also:
    `NodeReferenceTable`, `Node.cloneTree()`, `DanglingReferenceException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD